<?php

namespace Drupal\gridstack;

use Drupal\blazy\BlazyFormatter;

/**
 * Provides GridStack formatter.
 */
class GridStackFormatter extends BlazyFormatter implements GridStackFormatterInterface {

  /**
   * {@inheritdoc}
   */
  public function buildSettings(array &$build, $items) {
    // Prepare integration with Blazy.
    $settings  = &$build['settings'];
    $settings  = array_merge($settings, GridStackDefault::fixedSettings());
    $settings += GridStackDefault::htmlSettings();

    // Pass basic info to parent::buildSettings().
    parent::buildSettings($build, $items);

    $this->getModuleHandler()->alter('gridstack_settings', $build, $items);
  }

}
