<?php

namespace Drupal\gridstack;

/**
 * Provides a base interface for GridStack plugins.
 */
interface GridStackPluginManagerInterface {

  /**
   * Returns an instance of a plugin given a plugin id.
   *
   * @param string $id
   *   The plugin id.
   * @param array $configuration
   *   The optional configuration.
   *
   * @return object
   *   Return instance of GridStack plugin.
   */
  public function load($id, array $configuration = []);

}
